#include <stdio.h>
#include <math.h>
#include "cl.h"

int slide = 0;	
const int MAXBUF = 256;
char save[MAXBUF];
TDrawerDef drdata;

//  
int generate (const char* filename, const char* extension, TDrawerType type) {
	if (*filename=='-' || *filename=='?') return 0;
	//   
    const char *s, *point = filename, *shortname = filename;
    for (s=filename; *s; s++) {
    	if (*s=='/' || *s=='\\') shortname = s+1;
        if (*s=='.') point = s;
    }
    if (point<=shortname) point = s;
	char name[MAXBUF];
	strncpy (name, shortname, point-shortname);
	name[point-shortname] = '\0';
	sprintf (drdata.filename=save, "%s.%s", name, extension);
	//  
	printf ("doing %s\n", drdata.filename);
	//  
	CL_DataLine (&slide, "#NewSlide");
	CL_DataFile (&slide, filename);
	CL_DataLine (&slide, "#StatusBar.Visible off");
	//  
	drdata.Rect.x1=0; drdata.Rect.y1=0; 
	drdata.Rect.x2=548; drdata.Rect.y2=412;
	drdata.type = type;
	CL_DrawerCreate (&drdata);
	//    
	CL_SlideSetRect (slide, 2, 2, 546, 410);
	CL_SlideMaxZoom (slide);
	CL_SlideRefresh (slide);
	CL_SlideDraw (slide);
	if (type==CL_DRAWER_GIF)
		CL_DrawerSave ();
	//CL_DataLine (&slide, "#Echo off");
	//CL_DataLine (&slide, "#DumpSlidesList");
	return 1;
}

void usage () {
	printf ("ChartLib v1.03   (c) K.Vorontsov, MICEX, 1999-2001\n");
	printf ("CHD (CHart Description format) converter to GIF, GPT and EMF.\n");
	printf ("chdConv usage:\n");
	printf ("    chdConv [-gif] f1.chd f2.chd ...  -convert files to Compuserve GIF\n");
	printf ("    chdConv -gpt f1.chd f2.chd ...  -convert files to Graphics Primitives Text\n");
	printf ("    chdConv -emf f1.chd f2.chd ...  -convert files to Enhanced Metafile\n");
	printf ("    chdConv -wmf f1.chd f2.chd ...  -convert files to Windows Metafile\n");
	
}

int main (int argc, char* argv[]) {
	if (argc==1) {
		usage();
		return 0;
	}
	TDrawerType otype = CL_DRAWER_GIF;
	const char* ext="gif";
	CL_WorkStart ();
	CL_WorkDebug ("chdConv.log", 0);
	for (int a=1; a<argc; a++) {
		if (*argv[a]=='-') {
			ext = argv[a]+1;
			if (strcmp(ext,"gif")==0) otype = CL_DRAWER_GIF;
			else if (strcmp(ext,"gpt")==0) otype = CL_DRAWER_GPT;
			else if (strcmp(ext,"emf")==0) otype = CL_DRAWER_EMF;
			else if (strcmp(ext,"wmf")==0) otype = CL_DRAWER_WMF;
		}
		//       
		else if (*argv[a]=='+')
			CL_DataFile (&slide, argv[a]+1);
		//  ?  
		else if (*argv[a]=='?')
			usage ();
		//   
		else
			generate (argv[a], ext, otype);
	}
	CL_WorkFinish ();	
	//printf ("Press [Enter]..."); getchar();
	return 0;
}

