unit Main;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls,
	Forms, Dialogs,	ExtCtrls, SliChart, StdCtrls, ToolWin, ComCtrls, ImgList;

//    
type
	TfrmDrawer = class(TForm)
		chdBox: TSliChart;
		barStatus: TStatusBar;
		barTools: TToolBar;
		lstImages: TImageList;
		timSlidePlay: TTimer;
		diaSaveAs: TSaveDialog;
		diaOpen: TOpenDialog;
		//      
		tobFile: TToolButton;
		tobView: TToolButton;
		tobSelect: TToolButton;
		tobSlide: TToolButton;
		tobSeries: TToolButton;
		tobWindows: TToolButton;
		tobHelp: TToolButton;
		tobSeparator: TToolButton;
		//   ""
		tobFileLoadNew: TToolButton;
		tobFileLoadReplace: TToolButton;
		tobFileLoadOnSlide: TToolButton;
		tobFileLoadWindow: TToolButton;
		tobFilePrint: TToolButton;
		tobFileSaveBMP: TToolButton;
		tobFileSaveEMF: TToolButton;
		tobFileSaveGIF: TToolButton;
		tobFileExit: TToolButton;
		//   " "
		tobViewNearOff: TToolButton;
		tobViewNearSelected: TToolButton;
		tobViewNearAll: TToolButton;
		tobViewRefresh: TToolButton;
		tobViewMaxZoom: TToolButton;
		tobViewBuffered: TToolButton;
		//   "  "
		tobSelectAdd: TToolButton;
		tobSelectSub: TToolButton;
		tobSelectInvert: TToolButton;
		tobSelectRect: TToolButton;
		tobSelectRound: TToolButton;
		tobSelectHalf: TToolButton;
		tobSelectStrip: TToolButton;
		tobSelectOut: TToolButton;
		tobSelectAll: TToolButton;
		tobSelectTable: TToolButton;
		//   "  "
		tobSlideClip: TToolButton;
		tobSlideClear: TToolButton;
		tobSlideDelete: TToolButton;
		tobSlideFirst: TToolButton;
		tobSlidePrev: TToolButton;
		tobSlideNext: TToolButton;
		tobSlideLast: TToolButton;
		tobSlidePlay: TToolButton;
		tobSlideStop: TToolButton;
		tobSlidePlayCycled: TToolButton;
		tobSlideMoveFirst: TToolButton;
		tobSlideMoveLast: TToolButton;
		tobSlideMovePrev: TToolButton;
		tobSlideMoveNext: TToolButton;
		tobSlideInfo: TToolButton;
		//   "   "
		tobSeriesProperties: TToolButton;
		tobSeriesOnOff: TToolButton;
		tobSeriesToFront: TToolButton;
		//   ""
		tobWinList: TToolButton;
		tobWinJoinTable: TToolButton;
		//   ""
		tobHelpDoc: TToolButton;
		tobHelpHomepage: TToolButton;
		tobHelpHints: TToolButton;
		tobHelpQuestion: TToolButton;
		tobHelpAbout: TToolButton;
		// 
		procedure FormResize(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure CommandLineOptions ();
		procedure CommandLineLoadCHD ();
		procedure DisplayHint(Sender: TObject);
		procedure timSlidePlayTimer(Sender: TObject);
		// 
		procedure chdBoxStatusChange(Sender: TObject; var Info: TChartBackInfo);
		procedure chdBoxDataFile(Sender: TObject; var Info: TChartBackInfo);
		procedure chdBoxPropertyChange(Sender: TObject);
		procedure chdBoxPaintStart(Sender: TObject);
		procedure chdBoxPaintFinish(Sender: TObject);
		procedure chdBoxShowTable(Sender: TObject);
		procedure chdBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
		procedure chdBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
		//  
		procedure tobFileClick(Sender: TObject);
		procedure tobViewClick(Sender: TObject);
		procedure tobSeparatorClick(Sender: TObject);
		procedure tobSelectClick(Sender: TObject);
		procedure tobSlideClick(Sender: TObject);
		procedure tobSeriesClick(Sender: TObject);
		procedure tobWindowsClick(Sender: TObject);
		procedure tobHelpClick(Sender: TObject);
		//  ""
		procedure tobFileLoadNewClick(Sender: TObject);
		procedure tobFileLoadReplaceClick(Sender: TObject);
		procedure tobFileLoadOnSlideClick(Sender: TObject);
		procedure tobFileLoadWindowClick(Sender: TObject);
		procedure tobFileSaveEMFClick(Sender: TObject);
		procedure tobFileSaveBMPClick(Sender: TObject);
		procedure tobFileSaveGIFClick(Sender: TObject);
		procedure tobFilePrintClick(Sender: TObject);
		procedure tobFileExitClick(Sender: TObject);
		//  " "
		procedure tobViewNearOffClick(Sender: TObject);
		procedure tobViewNearSelectedClick(Sender: TObject);
		procedure tobViewNearAllClick(Sender: TObject);
		procedure tobViewRefreshClick(Sender: TObject);
		procedure tobViewMaxZoomClick(Sender: TObject);
		procedure tobViewBufferedClick(Sender: TObject);
		//  "  "
		procedure tobSelectRectClick(Sender: TObject);
		procedure tobSelectRoundClick(Sender: TObject);
		procedure tobSelectInvertClick(Sender: TObject);
		procedure tobSelectAddClick(Sender: TObject);
		procedure tobSelectSubClick(Sender: TObject);
		procedure tobSelectHalfClick(Sender: TObject);
		procedure tobSelectStripClick(Sender: TObject);
		procedure tobSelectOutClick(Sender: TObject);
		procedure tobSelectAllClick(Sender: TObject);
		procedure tobSelectTableClick(Sender: TObject);
		//  "  "
		procedure tobSlidePlayClick(Sender: TObject);
		procedure tobSlideStopClick(Sender: TObject);
		procedure tobSlidePrevClick(Sender: TObject);
		procedure tobSlideNextClick(Sender: TObject);
		procedure tobSlideFirstClick(Sender: TObject);
		procedure tobSlideLastClick(Sender: TObject);
		procedure tobSlideClearClick(Sender: TObject);
		procedure tobSlideDeleteClick(Sender: TObject);
		procedure tobSlideClipClick(Sender: TObject);
		procedure tobSlideMoveFirstClick(Sender: TObject);
		procedure tobSlideMovePrevClick(Sender: TObject);
		procedure tobSlideMoveNextClick(Sender: TObject);
		procedure tobSlideMoveLastClick(Sender: TObject);
		procedure tobSlideInfoClick(Sender: TObject);
		//  "   "
		procedure tobSeriesPropertiesClick(Sender: TObject);
		procedure tobSeriesOnOffClick(Sender: TObject);
		procedure tobSeriesToFrontClick(Sender: TObject);
		//  ""
		procedure tobWinListClick(Sender: TObject);
		procedure tobWinJoinTableClick(Sender: TObject);
		//  ""
		procedure tobHelpHintsClick(Sender: TObject);
		procedure tobHelpDocClick(Sender: TObject);
		procedure tobHelpQuestionClick(Sender: TObject);
		procedure tobHelpHomepageClick(Sender: TObject);
		procedure tobHelpAboutClick(Sender: TObject);
		procedure chdBoxSlideChange(Sender: TObject; var Info: TChartBackInfo);

	public
		FilmNo: integer;   //  
	private
		last_info: PChar;
		chicks: integer;
		procedure submenu (M: array of TToolButton);
		procedure default_menu();
		procedure chick (tob: TToolButton);
		procedure verify_table_size;
	end;

var
	frmDrawer: TfrmDrawer;

implementation

uses Table, About;
{$R *.DFM}

var
	cmd: array [0..300] of char;
	FilmCounter: integer;

procedure PARDON ();
begin
	Application.MessageBox(
		'   ',
		'!',
		MB_ICONSTOP+MB_OK);
end;

//  
procedure TfrmDrawer.FormCreate(Sender: TObject);
var
	i: integer;
begin
	{//   TSliChart  :
	chdBox:= TSliChart.Create(Self);
	chdBox.Parent:= Self;}
	//           
	Inc (FilmCounter);
	FilmNo:= FilmCounter;
	chdBox.DataLine (StrFmt(cmd,'#SetFilm=Film%d',[FilmNo]));
	//    
	chicks:= 12;
	for i:= 0 to barTools.ButtonCount-1 do barTools.Buttons[i].Tag:= 0;
	tobFileLoadNew.Tag:= 12;
	tobSelectAdd.Tag:= 6;
	tobSelectSub.Tag:= 7;
	tobSelectInvert.Tag:= 8;
	tobSelectAll.Tag:= 3;
	tobSelectTable.Tag:= 11;
	tobSlideClip.Tag:= 4;
	tobSlidePrev.Tag:= 9;
	tobSlideNext.Tag:= 10;
	tobSlidePlay.Tag:= 5;
	//   
	default_menu;
	barTools.Height:= chdBox.Top;
	barTools.ShowHint:= false;
	tobViewNearSelected.Down:= true;
	Application.OnHint := DisplayHint;
	barTools.Wrapable:= false;
	//   
	barStatus.Visible:= true;
	CommandLineOptions;
	if FilmNo=1 then begin
		SetLogName ('chdView.log'); 	//   
		CommandLineLoadCHD;
		end;
	//   
	chdBox.HasStatus:= not barStatus.Visible;
	if not barStatus.Visible then
		 barStatus.Height:= 0;
	//         
	Width:= Width+1; Width:= Width-1;
	{//       
	AssignFile(F, 'buttons.log');
	ReWrite(F);
	for p:= 0 to barTools.ButtonCount-1 do begin
		WriteLN (F, barTools.Buttons[p].Name);
	end;
	CloseFile(F);}
end;

//     ,      
procedure TfrmDrawer.CommandLineLoadCHD ();
var
	sp: string;
	p: integer;
begin
	if ParamCount>0 then begin
		for p:=1 to ParamCount do begin
			sp:= ParamStr(p);
			if sp[1]='-' then case sp[2] of
				'd', 'D': begin
					ChDir(Copy(sp,3,255));
					end;
				'n','N': begin
					chdbox.DataLine ('#NewSlide');
					end;
				'/', '\', '!': break;
				end // case
			else
				chdBox.DataFile (PChar(sp));
		end; // for
	end; // if
end;

//    ,    
procedure TfrmDrawer.CommandLineOptions ();
var
	sp, sopt: string;
	p, v, code: integer;
begin
	if ParamCount>0 then begin
		for p:=1 to ParamCount do begin
			sp:= ParamStr(p);
			sopt:= Copy (sp,3,255);
			if sp[1]='-' then case sp[2] of
				'w', 'W': begin
					Val (sopt,v,code); Width:= v;
					end;
				'h', 'H': begin
					Val (sopt,v,code); Height:= v;
					end;
				'x', 'X': begin
					Val (sopt,v,code); Left:= v;
					end;
				'y', 'Y': begin
					Val (sopt,v,code); Top:= v;
					end;
				's', 'S': begin
					barStatus.Visible:= false;
					end;
				'b', 'B': begin
					chdBox.HasBuffer:= true;
					tobViewBuffered.Down:= true;
					end;
				'/', '\', '!': break;
			end; // case
		end; // for
	end; // if
end;

procedure TfrmDrawer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	//tobSlideInfoClick (self);
	chdbox.DataLine ('#EchoFile');
	chdbox.DataLine ('#DeleteFilm');
	//Action:= caFree;
end;

//   
procedure TfrmDrawer.FormResize(Sender: TObject);
begin
	if barStatus.Visible then begin
		chdBox.Height:= ClientHeight - chdBox.Top - barStatus.Height - 1;
		barStatus.Panels[0].Width:= ClientWidth - 120;
		end
	else
		chdBox.Height:= ClientHeight - chdBox.Top;
	chdBox.Width:= ClientWidth;
	verify_table_size;
end;

//      
procedure TfrmDrawer.DisplayHint(Sender: TObject);
begin
	if barStatus.Visible then
		barStatus.Panels[0].Text:= GetLongHint (Application.Hint);
end;

//    
var
	LastX, LastY: integer;
procedure TfrmDrawer.chdBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
	LastX:= X;
	LastY:= Y;
end;

procedure TfrmDrawer.chdBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var clBuffer: PChar;
begin
	if (Shift=[ssCtrl]) and (Key=ord('Q')) then begin
		chdBox.ChartGetXYInfo (LastX, LastY, '', '": [x],[y],[z]"', clBuffer);
		Application.MessageBox(clBuffer, '', MB_ICONINFORMATION+MB_OK);
	end;
end;

//    

procedure TfrmDrawer.chdBoxStatusChange(Sender: TObject; var Info: TChartBackInfo);
begin
	if (@Info=nil) or not barStatus.Visible then exit;
	last_info:= Info.text;
	barStatus.Panels[0].Text:= Info.text;
end;

procedure TfrmDrawer.chdBoxDataFile(Sender: TObject; var Info: TChartBackInfo);
begin
	if (@Info=nil) then exit;
	if barStatus.Visible then
		barStatus.Panels[0].Text:= StrFmt (cmd, '  %s...', [Info.text]);
	Caption:= StrFmt (cmd,'chdView [%d] - %s', [FilmNo, ExtractFileName(Info.text)]);
end;

procedure TfrmDrawer.chdBoxSlideChange(Sender: TObject;	var Info: TChartBackInfo);
begin
	if (@Info=nil) then exit;
	Caption:= StrFmt (cmd,'chdView:%d - %s', [FilmNo, ExtractFileName(Info.text)]);
end;

procedure TfrmDrawer.chdBoxPaintStart(Sender: TObject);
begin
	if barStatus.Visible then
		barStatus.Panels[0].Text:= '  ...';
end;

procedure TfrmDrawer.chdBoxPaintFinish(Sender: TObject);
begin
	if barStatus.Visible then
		barStatus.Panels[0].Text:= ' ';
end;

procedure TfrmDrawer.chdBoxShowTable(Sender: TObject);
begin
	frmTable.OptimizeWindowSize;
	frmTable.Show;
	verify_table_size;
end;

//    
procedure TfrmDrawer.verify_table_size;
begin
	if tobWinJoinTable.Down and assigned(frmTable) and frmTable.Visible then begin
		frmTable.ChartForm:= nil;
		frmTable.Left:= Left + Width;
		frmTable.Height:= Height;
		frmTable.Top:= Top;
		frmTable.ChartForm:= Self;
	end;
end;

{//    ChartScreenToReal
procedure TfrmDrawer.chdBoxMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
	rx, ry, rz: double;
	cmd: array[0..200] of char;
begin
	chdBox.ChartScreenToReal (X, Y, rx, ry, rz);

	barStatus.Panels[0].Text:= last_info + StrFmt(cmd,' 	X=%g	Y=%g', [rx,ry]);
end;}

procedure TfrmDrawer.chdBoxPropertyChange(Sender: TObject);
begin
	case chdBox.SelectMode of
		smNone: barStatus.Panels[1].Text:= '';
		smSelect: barStatus.Panels[1].Text:= '';
		smUnselect: barStatus.Panels[1].Text:= '';
		smInvert: barStatus.Panels[1].Text:= '';
	end;
	case chdBox.SelectShape of
		shNone: barStatus.Panels[2].Text:= '';
		shRectangle: barStatus.Panels[2].Text:= '';
		shEllipse: barStatus.Panels[2].Text:= '';
		shHalf: barStatus.Panels[2].Text:= '';
		shStrip: barStatus.Panels[2].Text:= '';
	end;
end;

//   

//      [>>>]
procedure TfrmDrawer.submenu (M: array of TToolButton);
var
	i, k: integer;
begin
	k:= Low(M);
	for i:= 8 to barTools.ButtonCount-1 do begin
		barTools.Buttons[i].Visible:= false;
		if (k<=High(M)) and (barTools.Buttons[i]=M[k]) then begin
			M[k].Visible:= true;
			M[k].Wrap:= false;
			k:= k+1;
		end
	end;
end;

//  
procedure TfrmDrawer.chick (tob: TToolButton);
var
	i: integer;
begin
	for i:= 8 to barTools.ButtonCount-1 do
		if barTools.Buttons[i].Tag>tob.Tag then
			barTools.Buttons[i].Tag:= barTools.Buttons[i].Tag - 1;
	tob.Tag:= chicks;
end;

//    chicks   
procedure TfrmDrawer.default_menu();
var
	M: array of TToolButton;
	i, k, count: integer;
begin
	//    
	count:= 0;
	for i:= 8 to barTools.ButtonCount-1 do
		if barTools.Buttons[i].Tag>0 then
			Inc (count);
	//   
	SetLength (M, count);
	k:= 0;
	for i:= 8 to barTools.ButtonCount-1 do
		if barTools.Buttons[i].Tag>0 then begin
			M[k]:= barTools.Buttons[i];
			Inc(k);
		end;
	//  
	submenu (M);
	M:= nil;
end;

procedure TfrmDrawer.tobSeparatorClick(Sender: TObject);
begin
	default_menu;
end;

procedure TfrmDrawer.tobFileClick (Sender: TObject);
begin
	submenu ([
		tobFileLoadNew,
		tobFileLoadReplace,
		tobFileLoadOnSlide,
		tobFileLoadWindow,
		tobFileSaveBMP,
		tobFileSaveEMF,
		tobFileSaveGIF,
		tobFilePrint,
		tobFileExit
	]);
end;

procedure TfrmDrawer.tobViewClick (Sender: TObject);
begin
	submenu ([
		tobViewNearOff,
		tobViewNearSelected,
		tobViewNearAll,
		tobViewRefresh,
		tobViewMaxZoom,
		tobViewBuffered
	]);
end;

procedure TfrmDrawer.tobSelectClick(Sender: TObject);
begin
	submenu ([
		tobSelectAdd,
		tobSelectSub,
		tobSelectInvert,
		tobSelectAll,
		tobSelectRect,
		tobSelectRound,
		tobSelectHalf,
		tobSelectStrip,
		tobSelectOut,
		tobSelectTable
	]);
end;

procedure TfrmDrawer.tobSlideClick(Sender: TObject);
begin
	submenu ([
		tobSlideFirst,
		tobSlidePrev,
		tobSlideNext,
		tobSlideLast,
		tobSlidePlay,
		tobSlideStop,
		tobSlidePlayCycled,
		tobSlideClip,
		tobSlideClear,
		tobSlideDelete,
		tobSlideMoveFirst,
		tobSlideMovePrev,
		tobSlideMoveNext,
		tobSlideMoveLast,
		tobSlideInfo
	]);
end;

procedure TfrmDrawer.tobSeriesClick(Sender: TObject);
begin
	submenu ([
		tobSeriesProperties,
		tobSeriesOnOff,
		tobSeriesToFront
	]);
end;

procedure TfrmDrawer.tobWindowsClick(Sender: TObject);
begin
	submenu ([
		tobWinList,
		tobWinJoinTable
	]);
end;

procedure TfrmDrawer.tobHelpClick(Sender: TObject);
begin
	submenu ([
		tobHelpDoc,
		tobHelpQuestion,
		tobHelpHints,
		tobHelpHomepage,
		tobHelpAbout
	]);
end;

//  "  "

procedure TfrmDrawer.tobFileLoadNewClick(Sender: TObject);
var
	i: integer;
begin
	chick (tobFileLoadNew);
	diaOpen.Title:= '  ';
	if diaOpen.Execute then with diaOpen.Files do begin
		for i:=0 to Count-1 do begin
			ChDir (ExtractFileDir(Strings[i]));
			chdBox.DataLine ('#NewSlide');
			chdBox.DataLine (StrFmt(cmd,'#SetFilm=Film%d',[FilmNo]));
			chdBox.DataFile (PChar(Strings[i]));
		end;
		chdBox.SlideRefresh;
	end;
end;

procedure TfrmDrawer.tobFileLoadReplaceClick(Sender: TObject);
var
	i: integer;
begin
	chick (tobFileLoadReplace);
	diaOpen.Title:= ',   ';
	if diaOpen.Execute then with diaOpen.Files do begin
		for i:=0 to Count-1 do begin
			ChDir (ExtractFileDir(Strings[i]));
			chdBox.DataLine ('#ClearSlide');
			if chdBox.ChartLibError<0 then begin
				chdBox.DataLine ('#NewSlide');
				chdBox.DataLine (StrFmt(cmd,'#SetFilm=Film%d',[FilmNo]));
				end;
			chdBox.DataFile (PChar(Strings[i]));
		end;
		chdBox.SlideRefresh;
	end;
end;

procedure TfrmDrawer.tobFileLoadOnSlideClick(Sender: TObject);
var
	i: integer;
begin
	chick (tobFileLoadOnSlide);
	diaOpen.Title:= ',    ';
	if diaOpen.Execute then with diaOpen.Files do begin
		for i:=0 to Count-1 do begin
			ChDir (ExtractFileDir(Strings[i]));
			chdBox.DataFile (PChar(Strings[i]));
		end;
		chdBox.SlideRefresh;
	end;
end;

procedure TfrmDrawer.tobFileLoadWindowClick(Sender: TObject);
var
	clone: TfrmDrawer;
	i: integer;
begin
	chick (tobFileLoadWindow);
	diaOpen.Title:= '   ';
	if diaOpen.Execute then with diaOpen.Files do begin
		clone:= TfrmDrawer.Create (Self);
		clone.Caption:= StrFmt (cmd,'chdView [%d]',[clone.FilmNo]);
		clone.Show;
		for i:=0 to Count-1 do begin
			ChDir (ExtractFileDir(Strings[i]));
			if i>0 then begin
				clone.chdBox.DataLine ('#NewSlide');
				clone.chdBox.DataLine (StrFmt(cmd,'#SetFilm=Film%d',[FilmNo]));
				end;
			clone.chdBox.DataFile (PChar(Strings[i]));
		end;
		chdBox.SlideRefresh;
	end;
end;

procedure TfrmDrawer.tobFileSaveEMFClick(Sender: TObject);
var SlideNoPrev: integer;
begin
	chick (tobFileSaveEMF);
	{
	diaSaveAs.Title:= '    EMF';
	diaSaveAs.DefaultExt:= 'emf';
	diaSaveAs.Filter:= 'Windows metafile|*.emf';
	diaSaveAs.FileName:= StrFmt (cmd, 'Slide%d', [chdBox.SlideNo]);
	if diaSaveAs.Execute then with diaSaveAs.Files do begin
		chdBox.SaveAsEMF (PChar(Strings[0]));
	end;
	}
	diaSaveAs.Title:= '     EMF';
	diaSaveAs.DefaultExt:= 'emf';
	diaSaveAs.Filter:= 'Windows metafile|*.emf';
	diaSaveAs.FileName:= 'Slide';
	if diaSaveAs.Execute then with diaSaveAs.Files do begin
		chdBox.DataLine ('#Slide <<');
		repeat
			SlideNoPrev:= chdBox.SlideNo;
			chdBox.SaveAsEMF (PChar(
				ChangeFileExt (Strings[0], StrFmt(cmd,'%3.3d.emf',[chdBox.SlideNo]))
			));
			chdBox.DataLine ('#Slide >');
		until chdBox.SlideNo=SlideNoPrev;
	end;
end;

procedure TfrmDrawer.tobFileSaveBMPClick(Sender: TObject);
begin
	chick (tobFileSaveEMF);
	diaSaveAs.Title:= '    BMP';
	diaSaveAs.DefaultExt:= 'bmp';
	diaSaveAs.Filter:= 'Windows bitmap|*.bmp';
	diaSaveAs.FileName:= StrFmt (cmd, 'Slide%d', [chdBox.SlideNo]);
	if diaSaveAs.Execute then with diaSaveAs.Files do begin
		chdBox.SaveAsBMP (PChar(Strings[0]));
	end;
end;

procedure TfrmDrawer.tobFileSaveGIFClick(Sender: TObject);
begin
	chick (tobFileSaveGIF);
	diaSaveAs.Title:= '    GIF';
	diaSaveAs.DefaultExt:= 'gif';
	diaSaveAs.Filter:= 'CompuServe GIF|*.gif';
	diaSaveAs.FileName:= StrFmt (cmd, 'Slide%d', [chdBox.SlideNo]);
	if diaSaveAs.Execute then with diaSaveAs.Files do begin
		chdBox.SaveAsGIF (PChar(Strings[0]));
	end;
end;

procedure TfrmDrawer.tobFilePrintClick(Sender: TObject);
begin
	chick (tobFilePrint);
	chdBox.Print;
end;

procedure TfrmDrawer.tobFileExitClick(Sender: TObject);
begin
	chick (tobFileExit);
	Application.Terminate;
end;

//  "  "

procedure TfrmDrawer.tobViewNearOffClick(Sender: TObject);
begin
	chick (tobViewNearOff);
	chdBox.DataLine ('#ShowTN=never');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobViewNearSelectedClick(Sender: TObject);
begin
	chick (tobViewNearSelected);
	chdBox.DataLine ('#ShowTN=select');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobViewNearAllClick(Sender: TObject);
begin
	chick (tobViewNearAll);
	chdBox.DataLine ('#ShowTN=always');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobViewRefreshClick(Sender: TObject);
begin
	chick (tobViewRefresh);
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobViewMaxZoomClick(Sender: TObject);
begin
	chick (tobViewMaxZoom);
	chdBox.SlideMaxZoom;
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobViewBufferedClick(Sender: TObject);
begin
	chick (tobViewBuffered);
	chdBox.HasBuffer:= tobViewBuffered.Down;
end;

//  "  "

procedure TfrmDrawer.tobSelectAddClick(Sender: TObject);
begin
	chick (tobSelectAdd);
	chdBox.SelectMode:= smSelect;
end;

procedure TfrmDrawer.tobSelectSubClick(Sender: TObject);
begin
	chick (tobSelectSub);
	chdBox.SelectMode:= smUnselect;
end;

procedure TfrmDrawer.tobSelectInvertClick(Sender: TObject);
begin
	chick (tobSelectInvert);
	chdBox.SelectMode:= smInvert;
end;

procedure TfrmDrawer.tobSelectRectClick(Sender: TObject);
begin
	chick (tobSelectRect);
	chdBox.SelectShape:= shRectangle;
end;

procedure TfrmDrawer.tobSelectRoundClick(Sender: TObject);
begin
	chick (tobSelectRound);
	chdBox.SelectShape:= shEllipse;
end;

procedure TfrmDrawer.tobSelectHalfClick(Sender: TObject);
begin
	chick (tobSelectHalf);
	chdBox.SelectShape:= shHalf;
end;

procedure TfrmDrawer.tobSelectStripClick(Sender: TObject);
begin
	chick (tobSelectStrip);
	chdBox.SelectShape:= shStrip;
end;

procedure TfrmDrawer.tobSelectOutClick(Sender: TObject);
begin
	chick (tobSelectOut);
	chdBox.SelectOutside:= tobSelectOut.Down;
end;

procedure TfrmDrawer.tobSelectAllClick(Sender: TObject);
begin
	chick (tobSelectAll);
	chdBox.ChartSelectAll;
end;

procedure TfrmDrawer.tobSelectTableClick(Sender: TObject);
begin
	chick (tobSelectTable);
	chdBox.ShowTable;
end;

//  "  "

procedure TfrmDrawer.tobSlideClipClick(Sender: TObject);
begin
	chick (tobSlideClip);
	chdBox.CopyToClipBoard;
end;

procedure TfrmDrawer.tobSlideClearClick(Sender: TObject);
begin
	chick (tobSlideClear);
	chdBox.DataLine ('#ClearSlide');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlideDeleteClick(Sender: TObject);
begin
	chick (tobSlideDelete);
	chdBox.DataLine ('#DeleteSlide');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlidePrevClick(Sender: TObject);
var
	old_slide: integer;
begin
	chick (tobSlidePrev);
	old_slide:= chdBox.SlideNo;
	chdBox.DataLine ('#Slide <');
	if (chdBox.SlideNo=old_slide) and tobSlidePlayCycled.Down then
		chdBox.DataLine ('#Slide >>');
	if chdBox.SlideNo<>old_slide then
		chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlideNextClick(Sender: TObject);
var
	old_slide: integer;
begin
	chick (tobSlideNext);
	old_slide:= chdBox.SlideNo;
	chdBox.DataLine ('#Slide >');
	if (chdBox.SlideNo=old_slide) and tobSlidePlayCycled.Down then
		chdBox.DataLine ('#Slide <<');
	if chdBox.SlideNo<>old_slide then
		chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlideFirstClick(Sender: TObject);
begin
	chick (tobSlideFirst);
	chdBox.DataLine ('#Slide <<');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlideLastClick(Sender: TObject);
begin
	chick (tobSlideLast);
	chdBox.DataLine ('#Slide >>');
	chdBox.SlideRefresh;
end;

procedure TfrmDrawer.tobSlideMoveFirstClick(Sender: TObject);
begin
	chick (tobSlideMoveFirst);
	chdBox.DataLine ('#SlideMove <<');
end;

procedure TfrmDrawer.tobSlideMovePrevClick(Sender: TObject);
begin
	chick (tobSlideMovePrev);
	chdBox.DataLine ('#SlideMove <');
end;

procedure TfrmDrawer.tobSlideMoveNextClick(Sender: TObject);
begin
	chick (tobSlideMoveNext);
	chdBox.DataLine ('#SlideMove >');
end;

procedure TfrmDrawer.tobSlideMoveLastClick(Sender: TObject);
begin
	chick (tobSlideMoveLast);
	chdBox.DataLine ('#SlideMove >>');
end;

procedure TfrmDrawer.tobSlidePlayClick(Sender: TObject);
begin
	chick (tobSlidePlay);
	timSlidePlay.Enabled:= tobSlidePlay.Down;
end;

procedure TfrmDrawer.tobSlideStopClick(Sender: TObject);
begin
	chick (tobSlideStop);
	timSlidePlay.Enabled:= false;
	tobSlidePlay.Down:= false;
end;

procedure TfrmDrawer.timSlidePlayTimer(Sender: TObject);
var
	old_slide: integer;
begin
	old_slide:= chdBox.SlideNo;
	chdBox.DataLine ('#Slide >');
	if (chdBox.SlideNo=old_slide) and tobSlidePlayCycled.Down then
		chdBox.DataLine ('#Slide <<');
	if chdBox.SlideNo<>old_slide then
		chdBox.SlideRefresh
	else begin
		timSlidePlay.Enabled:= false;
		tobSlidePlay.Down:= false;
	end;
end;

procedure TfrmDrawer.tobSlideInfoClick(Sender: TObject);
begin
	chick (tobSlideInfo);
	chdBox.DataLine ('#DumpFile slides_info.$$$');
	chdBox.DataLine ('#DumpSlidesList');
	//WinExec ('notepad.exe slides_info.$$$', SW_SHOW);
	frmTable.LoadFile ('slides_info.$$$');
	frmTable.Show;
	verify_table_size;
	chdBox.DataLine ('#DumpFile');
	DeleteFile ('slides_info.$$$');
end;

//  " "

procedure TfrmDrawer.tobSeriesPropertiesClick(Sender: TObject);
begin
	//chick (tobSeriesProperties);
	PARDON;
end;

procedure TfrmDrawer.tobSeriesOnOffClick(Sender: TObject);
begin
	//chick (tobSeriesOnOff);
	PARDON;
end;

procedure TfrmDrawer.tobSeriesToFrontClick(Sender: TObject);
begin
	//chick (tobSeriesToFront);
	PARDON;
end;

//  " "

procedure TfrmDrawer.tobWinListClick(Sender: TObject);
begin
	//chick (tobWinList);
	PARDON;
end;

procedure TfrmDrawer.tobWinJoinTableClick(Sender: TObject);
begin
	chick (tobWinJoinTable);
	verify_table_size;
end;

//  "  ( )"

procedure TfrmDrawer.tobHelpDocClick(Sender: TObject);
begin
	//chick (tobHelpDoc);
	PARDON;
end;

procedure TfrmDrawer.tobHelpQuestionClick(Sender: TObject);
begin
	//chick (tobHelpQuestion);
	PARDON;
end;

procedure TfrmDrawer.tobHelpHintsClick(Sender: TObject);
begin
	chick (tobHelpHints);
	barTools.ShowHint:= tobHelpHints.Down;
end;

procedure TfrmDrawer.tobHelpHomepageClick(Sender: TObject);
begin
	//chick (tobHelpHomepage);
	PARDON;
end;

procedure TfrmDrawer.tobHelpAboutClick(Sender: TObject);
begin
	chick (tobHelpAbout);
	frmAbout.Left:= Left + (Width-frmAbout.Width) div 2;
	frmAbout.Top:= Top + (Height-frmAbout.Height) div 2;
	frmAbout.butClose.Visible:= true;
	frmAbout.ShowModal;
end;

begin
	FilmCounter:= 0;
end.




