unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SliChart, ExtCtrls;

type
  TForm1 = class(TForm)
    SliChart1: TSliChart;
    SliChart2: TSliChart;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure SliChart1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure SliChart2MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SliChart2PaintFinish(Sender: TObject);
    procedure SliChart1PaintFinish(Sender: TObject);
    procedure SliChart1PaintStart(Sender: TObject);
    procedure SliChart2PaintStart(Sender: TObject);
  private
    { Private declarations }
    alpha: double;
    finish1: boolean;
    finish2: boolean;
    procedure generate_SliChart1();
    procedure generate_SliChart2();
    procedure animate();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
	cmd: array [0..200] of char;

//      
procedure TForm1.FormCreate(Sender: TObject);
begin
	SetLogName ('animate.log');
	alpha:= 0.0;
	SliChart1.DataLine ('#NewSlide first');
	generate_SliChart1;
	SliChart1.SlideMaxZoom;
	SliChart2.DataLine ('#NewSlide second');
	generate_SliChart2;
	SliChart2.SlideMaxZoom;
end;

//   
procedure TForm1.generate_SliChart1();
begin
	with SliChart1 do begin
		SliChart1.DataFile ('config.chd');
		SliChart1.DataFile ('pind.chd');
	end;
end;

//   
procedure TForm1.generate_SliChart2();
begin
	with SliChart2 do begin
		//DataLine ('#DumpEcho on');
		DataLine ('#DeleteData');
		DataLine ('#SetFilm Film2');
		DataLine ('#Slide.Background 7 7 17 17');
		DataLine ('#Let t = @/10+0.095');
		DataLine (StrFmt (cmd, '#Let x = sin(t+%g)', [alpha]));
		DataLine ('#Let y = sin(2*t)');
		DataLine ('#Let lw = 10 / (1+0.5*abs(pointno-30))^0.7');
		DataLine ('#Let w = lw+3');
		DataLine ('#Series only: X=x Y=y LW=lw W=w LC=3 LG=2 LI=x');
		DataLine ('#SeriesSize 62');
		DataLine (StrFmt (cmd, '#Dump Slide==2==%d', [SlideNo]));
	end;
end;

//     
procedure TForm1.animate();
begin
	alpha:= alpha + PI/200;
 	if alpha>2*PI then alpha:= alpha - 2*PI;
  generate_SliChart2;
	SliChart2.SlideRefresh;
end;

//    -     
//    

procedure TForm1.SliChart1PaintFinish(Sender: TObject);
begin
	finish1:= true;
  if finish2 then animate;
end;

procedure TForm1.SliChart2PaintFinish(Sender: TObject);
begin
	finish2:= true;
  if finish1 then animate;
end;

procedure TForm1.SliChart1PaintStart(Sender: TObject);
begin
	finish1:= false;
end;

procedure TForm1.SliChart2PaintStart(Sender: TObject);
begin
	finish2:= false;
end;

//    -   
procedure TForm1.Timer1Timer(Sender: TObject);
begin
	//if not (SliChart1.Busy or SliChart2.Busy) then animate;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with SliChart2 do begin
		DataLine ('#DumpDataStructure');
		DataLine ('#DumpSeriesStructure');
		DataLine ('#DumpSlidesList');
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
	SliChart1.Width:= ClientWidth - SliChart1.Left * 2;
  SliChart2.Width:= SliChart1.Width;
	SliChart2.Height:= ClientHeight - SliChart2.Top - SliChart1.Top;
end;

procedure TForm1.SliChart1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
	ActiveControl:= SliChart1;
end;

procedure TForm1.SliChart2MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
	ActiveControl:= SliChart2;
end;

end.
