unit ChartLib;

interface

const
  //   
	CL_DRAWER_GIF = 3;  // GIF-
	CL_DRAWER_WIN = 4;  //    ,   Windows    (HDC)
	CL_DRAWER_WMF = 5;  // Windows 
	CL_DRAWER_EMF = 6;  // Enhanced Windows 

  //   
	CL_DATA_NODATA = 0; //   
	CL_DATA_BYTE = 1;   //  
	CL_DATA_REAL = 2;   //  
	CL_DATA_TEXT = 3;   //  char*

  //  
	CL_STAGE_BEGIN = 0;      //  
	CL_STAGE_BACKGROUND = 1; //  , , ,  
	CL_STAGE_FILLS = 2;      // 
	CL_STAGE_BOXES = 3;      // 
	CL_STAGE_HISTOGRAMS = 4; // 
	CL_STAGE_CANDLES = 5;    // 
	CL_STAGE_LINES = 6;      //    
	CL_STAGE_POINTS = 7;     // 
	CL_STAGE_ACTPOINT = 8;   //  
	CL_STAGE_FINDPOINT = 9;  //    
	CL_STAGE_STATUS = 10;    //        
	CL_STAGE_DYNAMENTS = 11; //  
	CL_STAGE_END = 12;       // 

	//   ,   TChartBackInfo.event
	CL_CBACK_DATACHANGE = 1;   //  
	CL_CBACK_ZOOM = 2;   // 
	CL_CBACK_POINTACTIVATE = 3;   //  
	CL_CBACK_POINTSELECT = 4;   //      
	CL_CBACK_POINTHIGHLIGHT = 5;   //  
	CL_CBACK_SCENECHANGE = 6;   //   3D-
	CL_CBACK_STATUSCHANGE = 7;   //   

type
	//  
	TDrawerDef = record
		drtype: integer;  //  
		filename: PChar;  //    GPT, GIF, WMF
		x1, y1, x2, y2: integer;   //    
		hdc: integer;  //    Windows-
	end;

	//  
	TInputData = record
		unused: integer;
		case dType: integer of
			CL_DATA_BYTE: (dByte: Smallint);  //  
			CL_DATA_REAL: (dReal: double); //  
			CL_DATA_TEXT: (dText: PChar);  //  char*
	end;

  //   
  TSelectShape = (shNone, shRectangle, shEllipse, shHalf, shStrip);

  //   
  TSelectMode = (smNone, smSelect, smUnselect, smInvert);

	// ,       
	TPointInfo = record
		panel_name: PChar;   //  
		series_name: PChar;   //  
		series: integer;   //    
		point: integer;   //    
		X, Y, Z: double;   //  
		text: PChar;   //   
		selected: integer; // ?
		can_be_selected: integer; //    ?
	end;

  //   
  TZoom = record
    x1, y1, z1: double;  //         
  	x2, y2, z2: double;  //        
  end;

  //    ChartLib
	//       
	TChartBackInfo = record
		slide: TObject;   //    ,  
		event: integer;   //  
		text: PChar;   //  ,  ,   
		area: PChar;   //   ,    
		series: integer;   //   
		point: integer;   //    
		selected: integer;   //  ?
		prec: TZoom;   //    
		curr: TZoom;   //    
	end;
  PChartBackInfo = ^TChartBackInfo;

	//   
	FChartCallBack = function (info: PChartBackInfo): integer; cdecl;

  TChartEvent = procedure (Sender: TObject; Info: PChartBackInfo) of object;

// ---------------------------------------------------------------------
//   

//  
function CL_WorkStart (): integer;
	cdecl; external 'ChartLib.DLL';

//  
function CL_WorkFinish (): integer;
	cdecl; external 'ChartLib.DLL';

//     , filename=0  
function CL_WorkDebug (filename: PChar): integer;
	cdecl; external 'ChartLib.DLL';

// ---------------------------------------------------------------------
//    

//      type
//  ,    clDrawerUse
function CL_DrawerCreate (var data: TDrawerDef): integer;
	cdecl; external 'ChartLib.DLL';

//   
function CL_DrawerUpdate (var data: TDrawerDef): integer;
	cdecl; external 'ChartLib.DLL';

//     drawerID
function CL_DrawerUse (drawer: integer): integer;
	cdecl; external 'ChartLib.DLL';

  //     drawerID
function CL_DrawerDelete (drawer: integer): integer;
	cdecl; external 'ChartLib.DLL';
{
//      (      ).
function CL_DrawerSave (filename: PChar): integer;
	cdecl; external 'ChartLib.DLL';
}
// ---------------------------------------------------------------------
//   

//      
function CL_SlideSetRect (slide: integer;
	xleft: integer; ytop: integer; xright: integer; ybottom: integer): integer;
	cdecl; external 'ChartLib.DLL';

//        
function CL_SlideMaxZoom (slide: integer): integer;
	cdecl; external 'ChartLib.DLL';

//  ()  (  ,  ,   ..)
function CL_SlideRefresh (slide: integer): integer;
	cdecl; external 'ChartLib.DLL';

//   
function CL_SlideDraw (slide: integer): integer;
	cdecl; external 'ChartLib.DLL';

//      stage
function CL_SlideBeginDraw (slide: integer; from_stage: integer=CL_STAGE_BEGIN): integer;
	cdecl; external 'ChartLib.DLL';

//      stage 
function CL_SlideContinueDraw (slide: integer; to_stage: integer=CL_STAGE_END): integer;
	cdecl; external 'ChartLib.DLL';

//     
function CL_SlideCallBack (slide: integer;
	callback: FChartCallBack; recepient: TObject): integer;
	cdecl; external 'ChartLib.DLL';
{
//      area 
function CL_SlideGetSize (slide: integer; area: integer;
	var xleft: integer; var ytop: integer; var xright: integer; var ybottom: integer): integer;
	cdecl; external 'ChartLib.DLL';
}
// ---------------------------------------------------------------------
//    

//     ,  #Slide, #Chart  .     slide
function CL_DataLine (var slide: integer; line: PChar): integer;
	cdecl; external 'ChartLib.DLL';

//     
function CL_DataVector (slide: integer; var data: TInputData): integer;
	cdecl; external 'ChartLib.DLL';

//          
function CL_DataFile (var slide: integer; filename: PChar): integer;
	cdecl; external 'ChartLib.DLL';

//        point     colname
function CL_DataGetValue (slide, row: integer; colname: PChar;
	var data: TInputData): integer;
	cdecl; external 'ChartLib.DLL';

//        point     colname
function CL_DataSetValue (slide, row: integer; colname: PChar;
	var data: TInputData): integer;
	cdecl; external 'ChartLib.DLL';

// ---------------------------------------------------------------------
//   
//     
function CL_ChartScreenToReal (slide, x, y: integer; var PX, PY, PZ: double): integer;
	cdecl; external 'ChartLib.DLL';

//     
function CL_ChartRealToScreen (slide: integer; xreal, yreal: double; var x, y: integer): integer;
	cdecl; external 'ChartLib.DLL';

{
//        
function CL_ChartGetZoom (slide: integer;
	var x1: double; var y1: double; var x2: double; var y2: double): integer;
	cdecl; external 'ChartLib.DLL';

//        
function CL_ChartGetMaxZoom (slide: integer;
	var x1: double; var y1: double; var x2: double; var y2: double): integer;
	cdecl; external 'ChartLib.DLL';

//       
function CL_ChartSetZoom (slide: integer;
	x1: double; y1: double; x2: double; y2: double): integer;
	cdecl; external 'ChartLib.DLL';
}

// ---------------------------------------------------------------------
//     

//   
function CL_ChartDrawPoint (slide: integer;
	var info: TPointInfo; stage: integer): integer;
	cdecl; external 'ChartLib.DLL';

//  , selectmode= 1- , 2-, 3- 
function CL_ChartSelectPoint (slide: integer; var info: TPointInfo; selectmode: integer): integer;
	cdecl; external 'ChartLib.DLL';

//   "  "
function CL_ChartSelectAll (slide, selectmode: integer): integer;
	cdecl; external 'ChartLib.DLL';

//   point   series.
function CL_ChartSetActivePoint (slide: integer;
	var info: TPointInfo; dir: integer): integer;
	cdecl; external 'ChartLib.DLL';

//     
function CL_ChartGetActivePoint (slide: integer; var info: TPointInfo): integer;
	cdecl; external 'ChartLib.DLL';

//    
function CL_ChartGetPointInfo (slide: integer; var info: TPointInfo): integer;
	cdecl; external 'ChartLib.DLL';

//       
function CL_ChartGetTableLine (slide: integer; var info: TPointInfo): integer;
	cdecl; external 'ChartLib.DLL';

// ---------------------------------------------------------------------
//     

//   
function CL_OnMouseDown (slide, x, y, buttons: integer): integer;
	cdecl; external 'ChartLib.DLL';

function CL_OnMouseMove (slide, x, y, buttons: integer): integer;
	cdecl; external 'ChartLib.DLL';

function CL_OnMouseUp   (slide, x, y, buttons: integer): integer;
	cdecl; external 'ChartLib.DLL';

//     
function CL_OnKeyPress (slide, keys, buttons: integer): integer;
	cdecl; external 'ChartLib.DLL';


implementation

end.
